<?php

function read_config($config_file, $debug = 0) {

    $fp = fopen($config_file,r);
    if(!is_resource($fp)) die("Can't open config file $config_file");
    $file_data = fread($fp,filesize($config_file));
    fclose($fp);

    // explode the var by \n's
    $data = explode("\n",$file_data);
    if($debug) echo "<pre>";

    foreach($data as $value) {
        $count++;
        // if it's not a comment
        if (preg_match("/^([\w\d]+)\s+=\s+[\"\']{0,1}(.*?)[\"\']{0,1}$/",$value,$matches)) {

            if (is_array($conf[$matches[1]]) && isset($matches[2]) ) {
                if($debug) echo "Adding value <strong>$matches[2]</strong> to existing key <strong>$matches[1]</strong>\n";
                $conf[$matches[1]] = array_push($conf[$matches[1]], $matches[2]);
            }
                                 
            elseif (isset($conf[$matches[1]]) && isset($matches[2]) ) {
                if($debug) echo "Adding value <strong>$matches[2]</strong> to existing key $matches[1]</strong>\n";
                $conf[$matches[1]] = array($conf[$matches[1]],$matches[2]);
            }
                                 
            elseif ($matches[2] !== "") {
                if($debug) echo "Adding value <strong>$matches[2]</strong> for key <strong>$matches[1]</strong>\n";
                $conf[$matches[1]] = $matches[2];
            }
            else {
                if($debug) echo "Key <strong>$matches[1]</strong> defined, but no value set\n";
            }
        } // end if it's not a comment

        // if there is something there and it's not a comment
        elseif ($value{0} !== "#" AND strlen(trim($value)) > 0) {
            echo "Error Invalid Config Entry --> Line:$count"; die;
        } // else if it's not a comment and there is something there
                                                                            
    } // foreach                                                        
    if($debug) echo "</pre>";

    return $conf;

} // end read_config


function libglue_param($param,$clobber=0)
{
	static $params = array();
	if(is_array($param))
	//meaning we are setting values
	{
		foreach ($param as $key=>$val)
		{
			if(!$clobber && isset($params[$key]))
			{
				echo "Error: attempting to clobber $key = $val\n";
				exit();
			}
			$params[$key] = $val;
		}
		return true;
	}
	else
	//meaning we are trying to retrieve a parameter
	{
		if(isset($params[$param])) return $params[$param];
		else return false;
	}
}

function dbh() { return libglue_param(libglue_param('dbh')); }
