<?php

/* ------------------- CVS INFO ---------------------- 
 *	
 *	$Source: /data/cvsroot/libglue/examples/login.php,v $
 *	last modified by $Author: hopson $ at $Date: 2003/06/26 22:41:28 $ 
 *
 * Libglue, a free php library for handling authentication 
 *   and session management. 
 *
 * Written and distributed by Oregon State University.
 *   http://oss.oregonstate.edu/libglue
 *
 * --------------------------------------------------- 
 */

// Path to your libglue config file:
require "./config.php";

/*
 * Usage:
 *   Use libglue like this:
 *		 0) Set up config.php with your database/ldap info
 *     1) require the libglue config to initialize settings
 *		 2) Make a page with a login form that has username and password fields
 *		 3) Pass username and password into authenticate()
 *		 4) If authenticate returns success, call:
 *				session_name();
 *				session_start();
 *		 5) If it fails, just send them back to the login page.
 *     6) On each of your content pages, require the config and 
 *			   call check_session() first thing - I'd actually recommend
 *				you create a separate file called 'lib.php' or something to
 *				take care of making sure all the appropriate files are required.
 *				If you are storing objects in your session, you _have_ to include
 *				the class declarations before called session_start().
 *
 */

//
// So we check for a username and password first
//
if ( $_POST['username'] && $_POST['password'] ) {
	$username = strip_tags($_POST['username']);
	$password = strip_tags($_POST['password']);
	$auth = authenticate($username, $password);
}
	
//
// If we succeeded in authenticating, create a session
//
if ( $auth->success == 1 ) 
{
	// $auth->info are the fields specified in the config file
	//   to retrieve for each user
	$user = $auth->info;
	session_name(libglue_param('sess_name'));
        session_set_cookie_params(0,"",libglue_param('sess_domain'));
	session_start();
	$_SESSION['user'] = $user;
	// now redirect to the main page
	header("Location: " . libglue_param('auth_page'));
	die();
}
else 
{
	// We can display $error on our login form if we want
	$error = $auth->error; 
}

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "DTD/xhtml1-transitional.dtd">
<html>
<head>
<title>Test login page</title>

<script type="text/javascript">
<!-- Begin
self.onload = function() 
{
	self.focus();
	document.login.username.focus();
}
// End -->
</script>

</head>

<body>

<br /><br /><br /><br />

<form name="login" enctype="multipart/form-data" method="post" style="Display:inline" action="<?=$_SERVER['PHP_SELF'];?>">
<center>
<table bgcolor="<?=$conf['sidebar_bgcolor']; ?>" align="center">
<tr>
<td>
	<table bgcolor="<?=$conf['sidebar_bgcolor']; ?>" align="center">
  	<tr><td colspan="2" align="center">
		<font style="header1" color="white"><?=$conf['login_message']; ?></font>
	</td></tr>
  	<tr><td><b><font size="2" color="white">login:</font></b></td>
		<td><input type="text" name="username" value="" /></td></tr>
  	<tr><td><b><font size="2" color="white">password:</font></b></td>
		<td><input type="password" name="password" value="" /></td></tr>
	<tr><td colspan="2" align="center"> 
		<font color="<?=$conf['error_color']; ?>"><?=$error; ?> </font>
	</td></tr>
	<tr><td colspan="2" align="center"><input type="submit" name="action" value="login" /></td></tr>
	</table>
</td></tr>
</table>

</center>
</form>
</body></html>
