<?php

/*

 $Id: show_hosts.inc,v 1.34 2003/07/21 07:43:24 vollmerk Exp $
 $Source: /data/cvsroot/maint/templates/show_hosts.inc,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header Show Hosts Template
	Show a listing of hosts given an array of host objects.

*/
?>


<? if ($conf['script'] != "search.php") { 
?>
<p align="left"><font class="header2">Showing Hosts from <?= $hosts[0]->zone->name; ?></font></p>
<? } ?>


<p>
Hosts in <font class="error">Red</font> are disabled, or blocked. <? $conf['help']->show_help_link("status"); ?><br />
Hosts in <font class="bandwdith_rate">Blue</font> have been rate-limited. <? $conf['help']->show_help_link("bandwidth_rate"); ?><br />
</p>

<?
show_template('tborder');
// total_items has to be passed in to determine how many page tabs to make
$conf['ui']->show_list_header($total_items);

?>

<table border="0" cellpadding="2" cellspacing="0" width="100%">
	<tr align="center" class="widget-title">
    		<td>
			<a href="<?= $conf['script']; ?>?action=<?= $conf['action']; ?>&amp;sort_type=host.name" title="<? $conf['help']->display_plain_txt("hostname"); ?>">Hostname</a> 
			<? if ($user->view->sort_type == "host.name") { $conf['ui']->show_arrow(); } ?>
			<a href="<?= $conf['script']; ?>?action=<?= $conf['action']; ?>&amp;sort_type=host.domain" title="<? $conf['help']->display_plain_txt("domain"); ?>">(Domain)</a>
			<? if ($user->view->sort_type == "host.domain") { $conf['ui']->show_arrow(); } ?>
		</td>
                <td>
			<a href="<?= $conf['script']; ?>?action=<?= $conf['action']; ?>&amp;sort_type=host.ip" title="<? $conf['help']->display_plain_txt("ip_address"); ?>">IP</a>
			<? if ($user->view->sort_type == "host.ip") { $conf['ui']->show_arrow(); } ?>
		</td>
                <td>
			<? $conf['help']->show_help_link('last_seen'); ?>
			<a href="<?= $conf['script']; ?>?action=<?= $conf['action']; ?>&amp;sort_type=host.last_seen" title="<? $conf['help']->display_plain_txt("last_seen"); ?>">Last Seen</a> 
			<? if ($user->view->sort_type == "host.last_seen") { $conf['ui']->show_arrow(); } ?>
			<a href="<?= $conf['script']; ?>?action=<?= $conf['action']; ?>&amp;sort_type=host.status" title="<? $conf['help']->display_plain_txt("operating_system"); ?>">(Status)</a>
			<? if ($user->view->sort_type == "host.status") { $conf['ui']->show_arrow(); } ?>
		</td>
               <td>
			<a href="<?= $conf['script']; ?>?action=<?= $conf['action']; ?>&amp;sort_type=host.os" title="<? $conf['help']->display_plain_txt("operating_system"); ?>">OS</a>
			<? if ($user->view->sort_type == "host.os") { $conf['ui']->show_arrow(); } ?>
		</td>
		<td>
			Action
		</td>
	</tr>

<?
foreach ($hosts as $host) {

	//Define the class to be used for this row. 
	if ($host->status =='disabled') { $used_class="disabled"; }
	elseif ($host->bandwidth_rate == 'limited') { $used_class="bandwidth_rate"; }
	elseif ($host->bandwidth_rate == 'blocked') { $used_class="disabled"; }
	else { $used_class="base"; }
?>



	<tr align="center" bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td class="<?= $used_class; ?>">
			<a href="host.php?action=show_host&amp;action_type=read&amp;host_id=<?echo $host->id ?>"><? $conf['ui']->display_field($host->hostname); ?></a>
		</td>
		<td class="<?= $used_class; ?>"><? if ( $host->ip->ip_int ) { $conf['ui']->display_field($host->ip->ip_addr); } else { echo "dynamic"; } ?></td>
		<td class="<?= $used_class; ?>"><? $conf['ui']->display_field($host->show_last_seen()); ?></td>
		<td class="<?= $used_class; ?>"><? $conf['ui']->display_field($host->os); ?></td>
		<td>
			<? if ($user->has_access($host->zone->id) ) { ?>
			<a href="host.php?action=show_host&amp;host_id=<?= $host->id ?>">Edit</a> |
				<? if ( $host->status == 'disabled' ) { ?>
					<? if ($conf['script'] == "search.php") { ?>
						<a href="host.php?action=enable_host&amp;search=1&amp;host_id=<?= $host->id; ?>">Enable</a> |
					<? } else { ?>
						<a href="host.php?action=enable_host&amp;host_id=<?= $host->id ?>">Enable</a> |
					<? } ?>
				<? } else { ?>
					<? if ($conf['script'] == "search.php") { ?>
						<a href="host.php?action=disable_host&amp;search=1&amp;host_id=<?= $host->id; ?>">Disable</a> |
					<? } else { ?>
					<a href="host.php?action=disable_host&amp;host_id=<?= $host->id ?>">Disable</a> |
					<? } ?>
				<? } // if ?>
			<a href="host.php?action=Delete&amp;host_id=<?= $host->id ?>">Delete</a>
			<? } else { ?>
			<a href="host.php?action=show_host&amp;action_type=read&amp;host_id=<?= $host->id ?>">View</a>
			<? } ?>	
		</td>
	</tr>

<?
}
?>
	
</table>
<? 
	$conf['ui']->show_list_header($total_items);
	show_template('bborder');
?>
